VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2715
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8595
   LinkTopic       =   "Form1"
   ScaleHeight     =   2715
   ScaleWidth      =   8595
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtRelation 
      Height          =   285
      Left            =   1440
      TabIndex        =   11
      Text            =   "Addresses_States"
      Top             =   1800
      Width           =   3735
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2520
      TabIndex        =   5
      Top             =   2280
      Width           =   735
   End
   Begin VB.TextBox txtNewField 
      Height          =   285
      Left            =   1440
      TabIndex        =   4
      Text            =   "StateAbbrev"
      Top             =   1440
      Width           =   3735
   End
   Begin VB.TextBox txtNewTable 
      Height          =   285
      Left            =   1440
      TabIndex        =   3
      Text            =   "States"
      Top             =   1080
      Width           =   3735
   End
   Begin VB.TextBox txtOldField 
      Height          =   285
      Left            =   1440
      TabIndex        =   2
      Text            =   "State"
      Top             =   720
      Width           =   3735
   End
   Begin VB.TextBox txtOldTable 
      Height          =   285
      Left            =   1440
      TabIndex        =   1
      Text            =   "Addresses"
      Top             =   360
      Width           =   3735
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   1440
      TabIndex        =   0
      Top             =   0
      Width           =   3735
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Relation Name"
      Height          =   195
      Index           =   5
      Left            =   0
      TabIndex        =   12
      Top             =   1800
      Width           =   1050
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "New Field"
      Height          =   195
      Index           =   4
      Left            =   0
      TabIndex        =   10
      Top             =   1440
      Width           =   705
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "New Table"
      Height          =   195
      Index           =   3
      Left            =   0
      TabIndex        =   9
      Top             =   1080
      Width           =   780
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Source Field"
      Height          =   195
      Index           =   2
      Left            =   0
      TabIndex        =   8
      Top             =   720
      Width           =   885
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Source Table"
      Height          =   195
      Index           =   1
      Left            =   0
      TabIndex        =   7
      Top             =   360
      Width           =   960
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Database"
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   6
      Top             =   0
      Width           =   690
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Note that the [brackets] are only necessary if the table or field
' names are Access reserved words.
Private Sub cmdGo_Click()
Dim db As DAO.Database
Dim new_tabledef As DAO.TableDef
Dim new_field As DAO.Field
Dim old_field As DAO.Field
Dim new_index As DAO.Index
Dim new_relation As DAO.Relation
Dim relation_field As DAO.Field
Dim sql As String

    ' Open the database.
    Set db = DBEngine.Workspaces(0).OpenDatabase(txtDatabase.Text, False, False)

    ' Remove junk from previous runs if it exists.
    On Error Resume Next
    db.Relations.Delete txtRelation.Text
    db.TableDefs(txtNewTable.Text).Indexes.Delete "idx" & txtNewField.Text
    db.TableDefs.Delete txtNewTable.Text
    On Error GoTo 0

    ' Make the new table.
    Set new_tabledef = db.CreateTableDef(txtNewTable.Text)
    Set old_field = db.TableDefs(txtOldTable.Text).Fields(txtOldField.Text)
    Set new_field = new_tabledef.CreateField(txtNewField.Text, old_field.Type, old_field.Size)
    new_tabledef.Fields.Append new_field
    db.TableDefs.Append new_tabledef

    ' Make the new field unique.
    Set new_index = new_tabledef.CreateIndex("idx" & txtNewField.Text)
    new_index.Fields.Append new_index.CreateField(txtNewField.Text)
    new_index.Unique = True
    new_tabledef.Indexes.Append new_index

    ' Copy the values into the new table.
    sql = "INSERT INTO [" & _
        txtNewTable.Text & "] ([" & _
        txtNewField.Text & "]) " & _
        "SELECT DISTINCT [" & txtOldField.Text & _
        "] FROM [" & txtOldTable.Text & "]"
    'Debug.Print sql
    db.Execute sql

    ' If the relation name is non-blank, then
    ' make the relation between the tables.
    If Len(txtRelation.Text) > 0 Then
        Set new_relation = db.CreateRelation( _
            txtRelation.Text, _
            txtNewTable.Text, _
            txtOldTable.Text)
        Set relation_field = new_relation.CreateField(txtNewField.Text)
        relation_field.ForeignName = txtOldField.Text
        new_relation.Fields.Append relation_field
        db.Relations.Append new_relation
    End If

    ' Close the database.
    db.Close

    MsgBox "Done"
End Sub

Private Sub Form_Load()
Dim db_name As String

    db_name = App.Path
    If Right$(db_name, 1) <> "\" Then db_name = db_name & "\"
    txtDatabase.Text = db_name & "People.mdb"
End Sub


Private Sub Form_Resize()
Dim wid As Single
Dim ctl As Control

    wid = ScaleWidth - txtDatabase.Left
    If wid < 120 Then wid = 120
    For Each ctl In Me.Controls
        If TypeOf ctl Is TextBox Then ctl.Width = wid
    Next ctl

    cmdGo.Left = (ScaleWidth - cmdGo.Width) / 2
End Sub


